<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: Moco Developer Guide</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('mocodevguide.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">Moco Developer Guide </div>  </div>
</div><!--header-->
<div class="contents">
<div class="toc"><h3>Table of Contents</h3>
<ul><li class="level1"><a href="#implorg">Organization of classes</a><ul><li class="level2"><a href="#stepbystep">What happens when you call solve()?</a></li>
<li class="level2"><a href="#implmocoproblemrep">The MocoProblemRep class</a></li>
</ul>
</li>
<li class="level1"><a href="#impldiverse">Supporting diverse formulations using OpenSim and Simbody</a><ul><li class="level2"><a href="#implkincon">Kinematic constraints</a></li>
<li class="level2"><a href="#implimplicitmultibody">Implicit multibody dynamics</a><ul><li class="level3"><a href="#implimplicitkincon">Implicit multibody dynamics with kinematic constraints</a></li>
</ul>
</li>
<li class="level2"><a href="#implimplicitauxiliary">Implicit auxiliary dynamics</a></li>
<li class="level2"><a href="#implpreskin">Prescribed kinematics</a><ul><li class="level3"><a href="#implpreskinkincon">Prescribed kinematics with kinematic constraints</a></li>
</ul>
</li>
</ul>
</li>
<li class="level1"><a href="#implstagedep">MocoGoal stage dependency</a></li>
</ul>
</div>
<div class="textblock"><p>This guide explains the organization of code in Moco and how direct collocation schemes are implemented using an <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> model.</p>
<h1><a class="anchor" id="implorg"></a>
Organization of classes</h1>
<p>Moco is organized as multiple pairs of "problem" and "solver" classes at different abstraction levels.</p>
<div class="image">
<object type="image/svg+xml" data="MocoImplementationDiagram.svg" width="700px" style="pointer-events: none;"></object>
</div>
<p><em>Organization of classes in Moco. Abstract classes are denoted by dashed lines.</em></p>
<p><a class="el" href="classOpenSim_1_1MocoProblem.html" title="A description of an optimal control problem, backed by OpenSim Models.">MocoProblem</a> describes a direct collocation problem using an <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> <a class="el" href="classOpenSim_1_1Model.html" title="A concrete class that specifies the interface to a musculoskeletal model.">Model</a>, and <a class="el" href="classOpenSim_1_1MocoSolver.html" title="Once the solver is created, you should not make any edits to the MocoProblem.">MocoSolver</a> is an abstract class for solving MocoProblems. Moco provides two MocoSolvers: <a class="el" href="classOpenSim_1_1MocoTropterSolver.html" title="Solve the MocoProblem using the tropter direct collocation library.">MocoTropterSolver</a> and <a class="el" href="classOpenSim_1_1MocoCasADiSolver.html" title="This solver uses the CasADi library (https://casadi.org) to convert the MocoProblem into a generic no...">MocoCasADiSolver</a>. <a class="el" href="classOpenSim_1_1MocoTropterSolver.html" title="Solve the MocoProblem using the tropter direct collocation library.">MocoTropterSolver</a> contains a problem-solver pair for optimal control problems: TropterProblem (which derives from tropter::Problem) and tropter::DirectCollocation (tropter is not exposed in Doxygen). To solve the optimal control problem, tropter::DirectCollocation employs a problem-solver pair for generic nonlinear optimization: tropter::Transcription (which derives from tropter::optimization::Problem) and tropter::optimization::Solver. The <a class="el" href="classOpenSim_1_1MocoCasADiSolver.html" title="This solver uses the CasADi library (https://casadi.org) to convert the MocoProblem into a generic no...">MocoCasADiSolver</a> employs the problem-solver pair of MocoCasOCProblem (deriving from CasOC::Problem) and CasOC::Solver.</p>
<p>These pairs of classes allow a separation between how a user specifies a problem and the method used to solve the problem. The <a class="el" href="classOpenSim_1_1MocoProblem.html" title="A description of an optimal control problem, backed by OpenSim Models.">MocoProblem</a> class contains only user input and describes the physical optimal control problem. The <a class="el" href="classOpenSim_1_1MocoSolver.html" title="Once the solver is created, you should not make any edits to the MocoProblem.">MocoSolver</a> classes allow the user to configure the numerical method used to solve the problem.</p>
<h2><a class="anchor" id="stepbystep"></a>
What happens when you call solve()?</h2>
<p>One way to learn the Moco codebase is to use a debugger to step through the code that is executed when invoking MocoStudy::solve(). Here, we walk through some of the key steps for you when using <a class="el" href="classOpenSim_1_1MocoCasADiSolver.html" title="This solver uses the CasADi library (https://casadi.org) to convert the MocoProblem into a generic no...">MocoCasADiSolver</a>.</p>
<ol type="1">
<li>MocoStudy::solve(): solve the <a class="el" href="classOpenSim_1_1MocoProblem.html" title="A description of an optimal control problem, backed by OpenSim Models.">MocoProblem</a> with the requested <a class="el" href="classOpenSim_1_1MocoSolver.html" title="Once the solver is created, you should not make any edits to the MocoProblem.">MocoSolver</a>.</li>
<li><a class="el" href="classOpenSim_1_1MocoProblem.html#a72e79d8ac47f31660af681e2ccd13cc9" title="Create an instance of MocoProblemRep, which fills in additional state and control bounds,...">MocoProblem::createRep()</a>: Create a <a class="el" href="classOpenSim_1_1MocoProblemRep.html" title="The primary intent of this class is for use by MocoSolvers, but users can also use this class to appl...">MocoProblemRep</a> from the <a class="el" href="classOpenSim_1_1MocoProblem.html" title="A description of an optimal control problem, backed by OpenSim Models.">MocoProblem</a> (see below). Initialize goals, path constraints, parameters, etc.</li>
<li>MocoSolver::solve(): Invoke the derived class' solveImpl().</li>
<li>MocoCasADiSolver::solveImpl(): Create a CasOC::Problem, CasOC::Solver, and solve the CasOC::Problem.</li>
<li>MocoCasADiSolver::createCasOCProblem(): Create a MocoCasOCProblem, which derives from CasOC::Problem. Add states, controls, costs, endpoint constraints, path constraints, etc. to the CasOC::Problem.</li>
<li>MocoCasADiSolver::createCasOCSolver(): Copy solver settings from <a class="el" href="classOpenSim_1_1MocoCasADiSolver.html" title="This solver uses the CasADi library (https://casadi.org) to convert the MocoProblem into a generic no...">MocoCasADiSolver</a> into an instance of CasOC::Solver.</li>
<li>CasOC::Solver::solve().</li>
<li>CasOC::Solver::createTranscription(): Creates either CasOC::Trapezoidal or CasOC::HermiteSimpson.</li>
<li>CasOC::Transcription::solve().</li>
<li>CasOC::Transcription::transcribe(): Convert the CasOC::Problem into a nonlinear program using a given transcription scheme.</li>
<li>casadi::nlpsol(): Create a CasADi <a class="el" href="classOpenSim_1_1Function.html" title="An abstract class for representing a function.">Function</a> for solving the nonlinear program. After this call, we invoke this function to solve the problem.</li>
<li><a class="el" href="classOpenSim_1_1MocoStudy.html" title="The top-level class for solving a custom optimal control problem.">MocoStudy</a> returns a <a class="el" href="classOpenSim_1_1MocoSolution.html" title="Return type for MocoStudy::solve().">MocoSolution</a>.</li>
</ol>
<p>The <a class="el" href="classOpenSim_1_1MocoTropterSolver.html" title="Solve the MocoProblem using the tropter direct collocation library.">MocoTropterSolver</a> follows similar steps.</p>
<h2><a class="anchor" id="implmocoproblemrep"></a>
The MocoProblemRep class</h2>
<p>The <a class="el" href="classOpenSim_1_1MocoSolver.html" title="Once the solver is created, you should not make any edits to the MocoProblem.">MocoSolver</a> interacts with the <a class="el" href="classOpenSim_1_1MocoProblem.html" title="A description of an optimal control problem, backed by OpenSim Models.">MocoProblem</a> through the intermediate class <a class="el" href="classOpenSim_1_1MocoProblemRep.html" title="The primary intent of this class is for use by MocoSolvers, but users can also use this class to appl...">MocoProblemRep</a>. This class exists to:</p>
<ol type="1">
<li>Validate the <a class="el" href="classOpenSim_1_1MocoProblem.html" title="A description of an optimal control problem, backed by OpenSim Models.">MocoProblem</a> and cache useful quantities.</li>
<li>Provide functionality, such as evaluating cost terms.</li>
<li>Prevent solvers from accidentally editing any user input; the solvers do not have access to the original <a class="el" href="classOpenSim_1_1MocoProblem.html" title="A description of an optimal control problem, backed by OpenSim Models.">MocoProblem</a>.</li>
</ol>
<p>The <a class="el" href="classOpenSim_1_1MocoProblemRep.html" title="The primary intent of this class is for use by MocoSolvers, but users can also use this class to appl...">MocoProblemRep</a> allows us not to worry about using invalid caches. Every time the <a class="el" href="classOpenSim_1_1Solver.html" title="The base (abstract) class for a family of objects responsible for solving system equations (statics,...">Solver</a> solves a problem, a new <a class="el" href="classOpenSim_1_1MocoProblemRep.html" title="The primary intent of this class is for use by MocoSolvers, but users can also use this class to appl...">MocoProblemRep</a> is created, ensuring that the most up-to-date settings in <a class="el" href="classOpenSim_1_1MocoProblem.html" title="A description of an optimal control problem, backed by OpenSim Models.">MocoProblem</a> are obeyed.</p>
<h1><a class="anchor" id="impldiverse"></a>
Supporting diverse formulations using OpenSim and Simbody</h1>
<p>The following problem formulations in Moco require careful consideration:</p>
<ol type="1">
<li>kinematic constraints,</li>
<li>expressing multibody dynamics as implicit differential equations, and</li>
<li>prescribing kinematics.</li>
</ol>
<p>We'll describe how Moco handles each of these formulations.</p>
<p>There are multiple ways to use a SimTK::System to compute desired quantities. SimTK::SimbodyMatterSubsystem contains many useful operators, but the conventional way to use a SimTK::System is to realize the system's SimTK::State through the Position, Velocity, Dynamics, and Acceleration stages. Using the SimTK::System in this way ensures that all calculations use the same input variables; this is described more concretely later. While the three formulations above could more easily be achieved using the SimTK::SimbodyMatterSubsystem operators, we employ strategies to handle these formulations using the standard realization stages. The goal of the following sections is to explain how we work the formulations above into the realization stages.</p>
<h2><a class="anchor" id="implkincon"></a>
Kinematic constraints</h2>
<p>When performing musculoskeletal simulations, we must satisfy the following equations for the multibody dynamics, kinematic constraints, and auxiliary dynamics (in that order):</p>
<p class="formulaDsp">
\[ \begin{alignat*}{2} M(q, p)\dot{u} + G(q, p)^T \lambda &amp;= f_{\textrm{app}}(t, y, x, p) - f_{\textrm{inertial}}(q, u, p) \\ 0 &amp;= \phi(q, p) \\ \dot{z}(t) &amp;= f_{\textrm{aux}}(t, y, x, \lambda, p). \\ \end{alignat*} \]
</p>
<p>The common way to solve these equations is to differentiate the kinematic constraints until generalized accelerations appear linearly, and then solve for generalized accelerations and Lagrange multipliers. This calculation occurs when realizing a SimTK::System to SimTK::Stage::Acceleration.</p>
<p class="formulaDsp">
\[ \begin{alignat*}{2} \begin{bmatrix} M(q, p) &amp; G(q, p)^T \\ G(q, p) &amp; 0 \end{bmatrix} \begin{bmatrix} \dot{u} \\ \lambda \end{bmatrix} &amp;= \begin{bmatrix} f_{\textrm{app}}(t, y, x, p) - f_{\textrm{inertial}}(q, u, p) \\ b(q, u) \end{bmatrix} \\ \dot{z}(t) &amp;= f_{\textrm{aux}}(t, y, x, \lambda, p) \\ \end{alignat*} \]
</p>
<p>Simbody then integrates \( u \) and \( z \) using the \( \dot{u} \) and \( \dot{z} \) calculated from the equations above. If the kinematic constraints are obeyed in the initial state, then theoretically, enforcing the constraints at the acceleration level (as done above) should cause the accelerations to remain enforced at the position and velocity levels. However, numerical integrators generate errors, causing the constraints to no longer be satisfied at the position and velocity levels. To fix this, Simbody projects the generalized coordinates and speeds onto the "constraint manifold" (that is, the multidimensional surface on which the system's kinematic constraints are satisfied; see SimTK::System::project()).</p>
<p>Handling kinematic constraints in direct collocation requires a different approach, because we cannot perform an internal "projection" within the direct collocation optimization problem. We use the method developed by Posa et al. [1]. In this scheme, the optimization solver searches for Lagrange multipliers that satisfy the equations above. This means that, when we use Simbody to evaluate multibody equations, we must tell Simbody what multipliers to use. However, this flow of data does not fit with Simbody's realization scheme, in which Simbody computes Lagrange multipliers itself. Some quantities such as joint reaction loads depend on Lagrange multipliers, and it is essential that we use the correct multipliers when computing such quantities (that is, the multipliers from the optimization instead of those computed by Simbody). To circumvent this issue, we employ two <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> Models: the original user-provided model with kinematic constraints, and a model in which all kinematic constraints are disabled. We use the first (constrained) model to calculate kinematic constraint violations and to convert the optimization solver's Lagrange multipliers into body and mobilizer forces using the constrained model's constraint Jacobian. Then we apply the multiplier-derived forces to the unconstrained model using the <a class="el" href="classOpenSim_1_1DiscreteForces.html" title="This class is a thin wrapper to Simbody&#39;s SimTK::Force::DiscreteForces class.">DiscreteForces</a> component. In <a class="el" href="classOpenSim_1_1MocoGoal.html" title="A goal is a term in the cost functional to be minimized, or a set of endpoint constraints that must l...">MocoGoal</a> and <a class="el" href="classOpenSim_1_1MocoPathConstraint.html" title="A path constraint to be enforced in the optimal control problem.">MocoPathConstraint</a>, we provide the unconstrained model with applied multiplier-derived forces, ensuring that joint reaction load calculations will use the correct multipliers.</p>
<p>Note that MocoGoals and MocoPathConstraints do not have direct access to the Lagrange multipliers; the unconstrained model does not have multipliers.</p>
<h2><a class="anchor" id="implimplicitmultibody"></a>
Implicit multibody dynamics</h2>
<p>When enforcing multibody dynamics using an implicit differential equation, we do not solve explicitly for \( \dot{u} \). Instead, \( \dot{u} \) is a variable in the optimal control problem and the optimizer searches for the value of \( \dot{u} \) that satisfies the multibody dynamics equation in its original form. This is similar to the "inverse dynamics" calculation, in which one knows \( \dot{u} \) and solves for the additional generalized forces (mobility forces) required for the multibody dynamics equation to hold:</p>
<p class="formulaDsp">
\[ f_{\mathrm{residual}} = M \dot{u} + f_{\mathrm{inertial}} - f_{\mathrm{app}}. \]
</p>
<p>Simbody provides the SimTK::SimbodyMatterSubsystem::calcResidual() "inverse
dynamics" operator to compute this residual force, and we could use this residual force in a path constraint to enforce multibody dynamics implicitly. However, the accelerations computed by realizing to SimTK::Stage::Acceleration (e.g., when computing a joint reaction load for a cost term) are different from the acceleration values we receive from the optimizer to perform calcResidual(). Therefore, we use an alternate scheme: we use SimTK::Motion to prescribe generalized accelerations, using the <a class="el" href="classOpenSim_1_1AccelerationMotion.html" title="This class is a thin wrapper to Simbody&#39;s SimTK::Motion for prescribing the acceleration of all degre...">AccelerationMotion</a> component. The SimTK::Motion comes with motion Lagrange multipliers \( \lambda_m \) that, when realizing to SimTK::Stage::Acceleration, are set to be the forces required for multibody dynamics to hold.</p>
<p class="formulaDsp">
\[ M \dot{u} + f_{\mathrm{inertial}} + \lambda_m = f_{\mathrm{app}}. \]
</p>
<p>That is, the motion multipliers are equivalent to the residual forces from calcResidual().</p>
<p>To enforce multibody dynamics, we use a path constraint to enforce the motion multipliers to be 0; that is, the force elements in the model must generate the forces necessary to satisfy the equations of motion.</p>
<h3><a class="anchor" id="implimplicitkincon"></a>
Implicit multibody dynamics with kinematic constraints</h3>
<p>With kinematic constraints, the equations of motion contain both kinematic constraint Lagrange multipliers \( \lambda_c \) and motion Lagrange multpliers \( \lambda_m \):</p>
<p class="formulaDsp">
\[ M(q)\dot{u} + f_{\textrm{inertial}}(q, u) + G(q)^T \lambda_c + \lambda_m = f_{\textrm{app}}(t, q, u, z, x). \]
</p>
<p>Handling kinematic constraints with implicit multibody dynamics is no different than how kinematic constraints are handled with explicit multibody dynamics. The optimization solver still has variables for the Lagrange multipliers and we enforce kinematic constraints as path constraints in the optimal control problem.</p>
<h2><a class="anchor" id="implimplicitauxiliary"></a>
Implicit auxiliary dynamics</h2>
<p>While the implicit multibody dynamics setting lives in the <a class="el" href="classOpenSim_1_1MocoSolver.html" title="Once the solver is created, you should not make any edits to the MocoProblem.">MocoSolver</a>, the implicit auxiliary dynamics settings live in the <a class="el" href="classOpenSim_1_1MocoProblem.html" title="A description of an optimal control problem, backed by OpenSim Models.">MocoProblem</a>, in the model components. This difference exists for two reasons: (1) the equations for multibody dynamics exist outside of the <a class="el" href="classOpenSim_1_1Model.html" title="A concrete class that specifies the interface to a musculoskeletal model.">Model</a>, while the equations for auxiliary dynamics exist within the <a class="el" href="classOpenSim_1_1Model.html" title="A concrete class that specifies the interface to a musculoskeletal model.">Model</a>; and (2) users may wish for only a subset of states to be handled implicitly, while the choice of dynamics mode for the multibody system affects all differential equations describing the multibody system.</p>
<p>Handling implicit dynamics requires that Moco (1) provides components with values for the derivatives of the auxiliary state variables, and (2) obtains the residuals of the implicit differential equations. For (1), <a class="el" href="classOpenSim_1_1MocoProblemRep.html" title="The primary intent of this class is for use by MocoSolvers, but users can also use this class to appl...">MocoProblemRep</a> provides a container of <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a>s and the names of the appropriate discrete state variables. For (2), <a class="el" href="classOpenSim_1_1MocoProblemRep.html" title="The primary intent of this class is for use by MocoSolvers, but users can also use this class to appl...">MocoProblemRep</a> provides a container of <a class="el" href="classOpenSim_1_1Output.html">Output</a>s that provide the residuals.</p>
<p>To satisfy the Model Component interface, components must implement Component::computeStateVariableDerivatives() to provide the explicit form of the differential equations; this is still true for components supporting an implicit mode. Components supporting implicit mode must also support explicit mode so that models used in direct collocation problems can still be used in time-stepping forward simulations. We do not want to end up in a situation where some models can be used only in direct collocation and some only in time-stepping forward simulations. The correct implementation of computeStateVariableDerivatives() in implicit mode is to set the derivative to the value of the discrete variable holding the state derivative that was supplied by Moco. Moco relies on computeStateVariableDerivatives() when enforcing <code>zdot = zeta</code> (where zeta is the control variable for the derivative of the auxiliary state variable).</p>
<p>The use of discrete state variables and component outputs instead of virtual functions (akin to computeStateVariableDerivatives()) was chosen to avoid modifying the <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a> class. The interface for specifying implicit auxiliary dynamics may change in the future to be more similar to the interface for explicit auxiliary dynamics.</p>
<h2><a class="anchor" id="implpreskin"></a>
Prescribed kinematics</h2>
<p>The situation of prescribed kinematics is similar to the situation for implicit multibody dynamics. In both cases, we are prescribing some portion of kinematics into the SimTK::System. For implicit dynamics, we are prescribing accelerations, and updating these accelerations with each optimization iteration. For prescribed kinematics, we prescribe coordinates, speeds, and accelerations based on user input. Given the similarity, we again use SimTK::Motion, but this time we enforce the motion at the position level using the <a class="el" href="classOpenSim_1_1PositionMotion.html" title="This class prescribes the value, speed, and acceleration of all coordinates in the model using SimTK:...">PositionMotion</a> component. No constraints are added (unlike with the prescribed_function property of <a class="el" href="classOpenSim_1_1Coordinate.html" title="A Coordinate is a ModelComponent for managing the access and behavior of a model&#39;s generalized coordi...">OpenSim::Coordinate</a>); instead, variables are replaced with data.</p>
<p>For a system without kinematic constraints, the equations of motion are:</p>
<p class="formulaDsp">
\[ M(\hat{q})\dot{\hat{u}} + f_{\textrm{inertial}}(\hat{q}, \hat{u}) + \lambda_m = f_{\textrm{app}}(t, \hat{q}, \hat{u}, z, x) \\ \]
</p>
<p>The hat denotes known quantities; the only variables are \( z \) and \( x \).</p>
<p>The Lagrange multipliers \( \lambda_m \) are the mobility forces required for the system to follow the prescribed kinematics. In our case, we do not want any ficticious forces generated, and so we require that \(\lambda_m = 0\). Simbody gives us access to these multipliers via SimTK::SimbodyMatterSubsystem::findMotionForces(), and we constrain the output of this function to be 0. Note that the only unknown in this equation is \( f_{\mathrm{app}} \); the other quantities are known because they only depend on kinematics. We enforce the equations of motion as path constraints, but there are no multibody states or defects in the optimal control problem.</p>
<p>Combining prescribed kinematics with implicit multibody dynamics is not possible: when kinematics are prescribed, there are no multibody dynamics to enforce. We only add the <a class="el" href="classOpenSim_1_1AccelerationMotion.html" title="This class is a thin wrapper to Simbody&#39;s SimTK::Motion for prescribing the acceleration of all degre...">AccelerationMotion</a> component to the model if the model does not contain a <a class="el" href="classOpenSim_1_1PositionMotion.html" title="This class prescribes the value, speed, and acceleration of all coordinates in the model using SimTK:...">PositionMotion</a>.</p>
<h3><a class="anchor" id="implpreskinkincon"></a>
Prescribed kinematics with kinematic constraints</h3>
<p>With kinematic constraints, the equations of motion are</p>
<p class="formulaDsp">
\[ M(\hat{q})\dot{\hat{u}} + f_{\textrm{inertial}}(\hat{q}, \hat{u}) + G(\hat{q})^T \lambda_c + \lambda_m = f_{\textrm{app}}(t, \hat{q}, \hat{u}, z, x) \\ \]
</p>
<p>\( G \) is the kinematic constraint Jacobian and \( \lambda_c \) are the kinematic constraint Lagrange multipliers. We still require \( \lambda_m = 0 \) but we must allow the kinematic constraints to apply forces. Applied forces affect what the constraint forces must be. Consider a point mass with degrees of freedom \( x \) and \( y \) and generalized forces \( F_x \) and \( F_y \) constrained to the line \( y = x \) and with prescribed motion \( y(t) = x(t) = \sin(t) \). Moco will solve for the forces \( F_x \) and \( F_y \) that can achieve this prescribed motion (by setting \( \lambda_m = 0 \) and solving for \( f_{\mathrm{app}} \), and the Lagrange multiplier \( \lambda_c \) will ensure that, regardless of the values of \( F_x \) and \( F_y \), the mass will remain on the line.</p>
<p>In this scenario, we do not include path constraints for the kinematic constraint errors: the generalized coordinates, speeds, and accelerations are no longer variables in the problem, and so the constraint errors are constant.</p>
<h1><a class="anchor" id="implstagedep"></a>
MocoGoal stage dependency</h1>
<p>MocoGoals can declare the SimTK::Stage upon which they depend. This allows solvers to decide how to efficiently prepare the inputs for a <a class="el" href="classOpenSim_1_1MocoGoal.html" title="A goal is a term in the cost functional to be minimized, or a set of endpoint constraints that must l...">MocoGoal</a>. Here, we detail what solvers must do for each Stage when computing an integrand:</p>
<ul>
<li>SimTK::Stage::Topology: set <a class="el" href="structOpenSim_1_1MocoGoal_1_1IntegrandInput.html#a2687a5617965b17c2b750ae70b835906" title="Time is available regardless of the stage dependency.">MocoGoal::IntegrandInput::time</a>.</li>
<li>SimTK::Stage::Model: set <a class="el" href="structOpenSim_1_1MocoGoal_1_1IntegrandInput.html#aa9c1d223d49f1e8b4b424b05f50d4fb4" title="Controls are available with a stage requirement of SimTK::Stage::Model.">MocoGoal::IntegrandInput::controls</a> to the raw controls from the optimizer. Provide implicit auxiliary dynamics derivatives.</li>
<li>SimTK::Stage::Instance: apply MocoParameters to the model.</li>
<li>SimTK::Stage::Time: set SimTK::State::updTime(), update SimTK::State::updY(), and prescribe kinematics. (If no motion were prescribed, then updating the state variables could occur for a stage dependency SimTK::Stage::Model. However, prescribing the kinematics requires setting time, and we do not want goals to behave differently whether or not kinematics are prescribed.)</li>
<li>SimTK::Stage::Dynamics: Update the state of the base model; not just the model with disabled constraints. Use the base model to compute kinematic constraint forces and apply them to the model with disabled constraints.</li>
<li>SimTK::Stage::Acceleration: Prescribe generalized accelerations (if using implicit multibody dynamics).</li>
</ul>
<p>Computing a goal value (that is, setting a <a class="el" href="structOpenSim_1_1MocoGoal_1_1GoalInput.html">MocoGoal::GoalInput</a>) follows the same rules, except they are repeated for initial and final time, state, and controls.</p>
<p>[1] M. Posa, S. Kuindersma, and R. Tedrake, “Optimization and stabilization of trajectories for constrained dynamical systems,” in Proceedings of the International Conference on Robotics and Automation (ICRA), Stockholm, Sweden, 2016. </p>
</div></div><!-- contents -->
</div><!-- PageDoc -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="mocomainpage.html">Moco</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:16 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
